#include <bits/stdc++.h>
using namespace std;
int resenje(long long int broj)
{
	if(broj == 1)
	return 1;
	
	long long int i,d=0,res=1;
	for(i=2;i<broj;i++)
	{
		if(d==0)
		{
			if(broj%i==0)
			{
				d=i;
			}
		}
		if(d!=0)
		{
			res=(res xor d);
			d=0;
		}
	}
	return (res xor broj);
}
int main()
{
	long long int n,k,i;cin>>n>>k;
	long long int niz[k],res[k];
	
	for(i=0;i<k;i++)
	{
		cin>>niz[i];
		res[i]=resenje(niz[i]);
	}
	for(i=0;i<k;i++)
	{
		cout<<res[i]<<" ";
	}
}